module Space exposing (main)

import AMR.Main as AMR
import Example.Counter as Example
import Help
import Html exposing (Html)
import Html.Attributes
import Json.Encode


main : Html Never
main =
    let
        encodedMsgs =
            Json.Encode.encode 0 (Json.Encode.list Example.encodeMsg msgs)

        encodedAmrModel =
            Json.Encode.encode 0 (AMR.encode amrModel)
    in
    Html.div []
        [ viewTitle ("500 messages encoded as " ++ String.fromInt (String.length encodedMsgs) ++ " characters")
        , viewData [ Html.text encodedMsgs ]
        , viewTitle ("are encoded with AMR into " ++ String.fromInt (String.length encodedAmrModel) ++ " characters")
        , viewData [ Html.text encodedAmrModel ]
        ]


msgs : List Example.Msg
msgs =
    List.map Example.msgFromInt (List.range 0 499)


amrModel : AMR.Model Example.Model
amrModel =
    List.foldl (Help.replayUpdate (AMR.update Example.update (always Cmd.none) Example.encodeMsg))
        (Tuple.first (AMR.init (Help.replayUpdate Example.update) Example.msgDecoder Nothing (Example.init ())))
        msgs


viewTitle : String -> Html Never
viewTitle title =
    Html.h1 [] [ Html.text title ]


viewData : List (Html Never) -> Html Never
viewData =
    Html.div [ Html.Attributes.style "word-break" "break-word" ]
